<template>
  <div
    ref="element"
    :class="{
      'ScheduledOrder--moving': moving,
      'ScheduledOrder--valid': order.valid,
    }"
    :draggable="true"
    :style="orderToStyle"
    class="ScheduledOrder"
    @dragend="end"
    @dragstart="move"
  >
    <span class="ScheduledOrder__title">{{ order.title }}</span>
    <span class="ScheduledOrder__id">{{ order.id }}</span>
    <template v-if="order.schedule">
      <time
        :datetime="order.schedule.start.toISOString()"
        class="ScheduledOrder__start"
        >{{ formatHour(order.schedule.start) }}
      </time>
      <time
        :datetime="order.schedule.end.toISOString()"
        class="ScheduledOrder__end"
        >{{ formatHour(order.schedule.end) }}
      </time>
    </template>
    <Icon
      v-if="order.valid"
      class="ScheduledOrder__valid"
      :icon="Icons.order.valid"
    />
  </div>
</template>

<script lang="ts">
import { computed, defineComponent, PropType, ref } from 'vue'
import moment from 'moment'
import { Order } from '@/types'
import { Icons } from '@/Icons'
import { Icon } from '@/components'
import { GREY_DEFAULT } from '@/helpers'

export default defineComponent({
  name: 'Home',
  components: { Icon },

  props: {
    order: {
      type: Object as PropType<Order>,
      required: true,
    },

    now: {
      type: Object,
      required: true,
    },

    resolution: {
      type: Number,
      required: true,
    },

    offsetNow: {
      type: Number,
      required: true,
    },
  },

  setup(props) {
    const element = ref<HTMLDivElement>()
    const moving = ref(false)

    const orderToStyle = computed(() => {
      const style = {
        backgroundColor: props.order.material.color,
        left: '',
        width: '',
        color:
          props.order.material.color !== GREY_DEFAULT ? 'white' : '#444444',
      }
      if (props.order.schedule) {
        style.left =
          moment(props.order.schedule.start).diff(props.now, 'hour', true) *
            props.resolution +
          props.offsetNow +
          'px'
        style.width =
          moment(props.order.schedule.end).diff(
            props.order.schedule.start,
            'hour',
            true
          ) *
            props.resolution +
          'px'
      }
      return style
    })

    return {
      Icons,
      moving,
      element,
      orderToStyle,
    }
  },

  methods: {
    formatHour(date: Date): string {
      return moment(date).format('HH:mm')
    },
    move(e: DragEvent) {
      this.moving = true
      if (e.dataTransfer) {
        e.dataTransfer.dropEffect = 'move'
        e.dataTransfer.effectAllowed = 'move'
        e.dataTransfer.setData('orderId', this.order.id)
        if (this.element) {
          e.dataTransfer.setData(
            'offset',
            (e.x - this.element.getBoundingClientRect().x).toString()
          )
        }
      }
    },
    end() {
      this.moving = false
    },
  },
})
</script>

<style lang="scss" scoped>
@use '../../style/variables' as v;

.ScheduledOrder {
  position: absolute;
  display: grid;
  grid-template-areas:
    'Title Title'
    'ID valid'
    'start stop';
  grid-template-rows: 1fr minmax(min-content, auto) minmax(min-content, auto);
  grid-template-columns: 1fr 1fr;
  gap: 0 0;
  height: 100%;
  max-height: v.$machine-lineHeight - v.$spacing;
  padding: 10px 20px;
  border-radius: 3px;
  color: white;
  box-shadow: 0 1px 2px rgba(0, 0, 0, 0.15);
  cursor: grab;

  &::before,
  &::after {
    content: '•••';
    position: absolute;
    top: 50%;
    color: rgba(0, 0, 0, 0.25);
    font-size: 23pt;
    transform: rotate(90deg) translateX(-50%);
  }

  &::after {
    right: -6px;
  }

  &--moving {
    background-image:
      repeating-linear-gradient(145deg,
      #ccc,
      #ccc 30px,
      #dbdbdb 30px,
      #dbdbdb 60px);
    color: #000;
    transition: background-color linear 200ms;
  }

  &__title {
    grid-area: Title;
    font-weight: 700;
    font-size: 10pt;
  }

  &__id {
    grid-area: ID;
    font-style: italic;
    font-size: 0.8em;
  }

  &__start {
    grid-area: start;
    align-self: flex-end;
    font-size: 0.8em;
  }

  &__end {
    grid-area: stop;
    align-self: flex-end;
    font-size: 0.8em;
    text-align: right;
  }

  &__valid {
    grid-area: valid;
    align-self: flex-end;
    justify-content: flex-end;
  }
}
</style>
